#include "test.h"
// #include <iostream>
#include <stdio.h>

__global__ void test(void) {
    // std::cout << "Hello CUDA!" << std::endl;
    printf("In the cuda function!\n");
}

__global__ void add(float *x, float *y, float *z, int n) {
    int index = threadIdx.x + blockIdx.x * blockDim.x;
    int stride = blockDim.x * gridDim.x;
    for (int i = index; i < n; i += stride) {
        z[i] = x[i] + y[i];
    }
}

// c = a + b
// a[i][j] = i * raw + j
// 2-dim: (m, k) * (k, n) = (m, n)
__global__ void MatMul(
        float* matPtr_a,
        float* matPtr_b,
        float* matPtr_c,
        int m,
        int k,
        int n
        ) {
    int c_row = blockIdx.x;
    int c_col = blockIdx.y;
    /*
    // printf("blockIdx.x = %d, blockIdx.y = %d, threadIdx.x = %d\n", c_row, c_col, threadIdx.x);
    printf("a[%d][%d] = %f\n", c_row, threadIdx.x, *(matPtr_a + c_row * k + threadIdx.x));
    // printf("c[%d][%d] = %f\n", c_row, c_col, *(matPtr_c));
    printf("b[%d][%d] = %f\n", threadIdx.x, c_col, *(matPtr_b + threadIdx.x * n + c_col));
    // printf("id = %d\n", c_col + threadIdx.x * n);
    *(matPtr_c + c_row * n + c_col) += 
    *(matPtr_a + c_row * k + threadIdx.x) * *(matPtr_b + threadIdx.x * n + c_col);
    printf("c[%d][%d] = %f\n", c_row, c_col, *(matPtr_c + c_row * n + c_col));
    // std::cout << *(matPtr_c + c_row * m + c_col) << std::endl;
    */
    for (int i = 0; i < k; i++) {
        *(matPtr_c + c_row * n + c_col) += 
        *(matPtr_a + c_row * k + i) * *(matPtr_b + i * n + c_col);
    }
}
